<!DOCTYPE html>
<html lang="en">
<head>
    <title>YSDA DB Course. Lecture 4.</title>
    <meta charset="utf-8">
    <meta http-equiv="x-ua-compatible" content="ie=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <link rel="stylesheet" href="shower/themes/yandex/styles/screen-16x9.css">

    <style type="text/css">
        code { display: block; white-space: pre; background-color: #EEE; }
        p.cloud { text-align: center; line-height: 1.5; }
        p.cloud span { font-size: 13pt; color: gray; padding: 0 20px 0 20px; white-space: nowrap; }
   </style>
</head>
<body class="shower list">
    <header class="caption">
        <h1>YSDA Databases 2023</h1>
    </header>

    <section class="slide" id="cover">
        <h1 style="margin-top: 150px;">Lecture 4. Log-structured Storage. Database Workloads.</h1>
    </section>

    <section class="slide">
        <h2>Plan</h2>

        <p>1. Log-structured storage organization.</p>
        <p>2. Index organized storage.</p>
        <p>3. OLTP, OLAP, HTAP workloads.</p>
        <p>4. NSM storage model (row store).</p>
        <p>5. DSM storage model (column store).</p>
    </section>

    <section class="slide">
        <h1>Slotted pages</h1>

        <p>We store an array of free slots in the page, each slot stores a pointer to the beginning of the tuple record and its length.
            This is used by almost all classical DBMS.</p>

        <img style="width: 90%; height: 60%;" src="pictures/slotted_pages.png"/>
    </section>

    <section class="slide">
        <h1>Issues</h1>

        <p>Fragmentation.</p>
        <p>Useless Disk I/O (Read/write amplification).</p>
        <p>Random Disk I/O.</p>
        <p>Object storages (S3, HDFS).</p>
    </section>

    <section class="slide">
        <h1>Log-structured file organization</h1>

        <p>The DBMS appends new log entries to an in memory data structures and when data structure size is greater than
            some limit writes data to disk.</p>

        <p><a href="https://www.cs.umb.edu/~poneil/lsmtree.pdf">LSM Tree paper</a></p>
        <p><a href="https://en.wikipedia.org/wiki/Log-structured_merge-tree">https://en.wikipedia.org/wiki/Log-structured_merge-tree</a></p>
        <p><a href="https://storage.googleapis.com/pub-tools-public-publication-data/pdf/68a74a85e1662fe02ff3967497f31fda7f32225c.pdf">Google Big Query paper</a></p>
    </section>

    <section class="slide">
        <h1>Log-structured file organization</h1>

        <p>Instead of storing tuples on pages, the DBMS stores only log records.
            The system adds log entries to the file about how the database was changed:</p>

        <p>1. INSERT saves the entire tuple.</p>
        <p>2. DELETE marks the tuple as deleted.</p>
        <p>3. UPDATE contains only attributes that have changed (or whole updated tuple).</p>
    </section>

    <section class="slide">
        <h1>Log-structured file organization</h1>

        <img style="width: 60%; height: auto;" src="pictures/log_structured_page_1.png"/>
    </section>

    <section class="slide">
        <h1>Log-structured file organization</h1>

        <img style="width: 60%; height: auto;" src="pictures/log_structured_page_2.png"/>
    </section>

    <section class="slide">
        <h1>Log-structured file organization</h1>

        <p>On each page data is almost always sorted by PRIMARY KEY called Sorted String Tables (SSTables).</p>
        <p>Various indexes can improve reading performance (sparse index, hash, bloom filter, cuckoo index).</p>

        <p><a href="https://en.wikipedia.org/wiki/Database_index">https://en.wikipedia.org/wiki/Database_index</a></p>
        <p><a href="https://en.wikipedia.org/wiki/Bloom_filter">https://en.wikipedia.org/wiki/Bloom_filter</a></p>
    </section>

    <section class="slide">
        <h1>Log-structured file compaction</h1>

        <p>Periodic compaction of log files.</p>

        <img style="float: left; width: 50%; height: auto;" src="pictures/log_structured_page_1.png"/>
        <img style="float: right; width: 50%; height: auto;" src="pictures/log_structured_page_3.png"/>
    </section>

    <section class="slide">
        <h1>Log-structured file compaction</h1>

        <img style="width: 100%; height: auto;" src="pictures/LSM_Tree.png"/>
    </section>

    <section class="slide">
        <h1>Log-structured file compaction</h1>

        <p>Different compaction strategies:</p>
        <p>1. Universal Compaction</p>
        <p>2. Level Compaction</p>
    </section>

    <section class="slide">
        <h1>Log-structured file organization</h1>

        <p>Two main implementations LevelDB, RocksDB.</p>
        <p>Used in systems such as Google BigTable, Apache HBASE, TiDB.</p>
    </section>

    <section class="slide">
        <h1>Index organized storage</h1>

        <p>B-Tree, Hash Index by PRIMARY KEY.</p>
        <p>Slotted pages are used to store data.</p>
        <p>MySQL, SQLite, Oracle, SQLServer.</p>
    </section>

    <section class="slide">
        <h1>Database Workloads</h1>

        <p>The relational model does not specify that we must store all the attributes of a tuple together on a single page.</p>
        <p>This may not actually be the best storage method for some types of workloads.</p>
    </section>

    <section class="slide">
        <h1>Database Workloads</h1>

        <p>Different workloads:</p>
        <p>OLTP</p>
        <p>OLAP</p>
        <p>HTAP</p>
    </section>

    <section class="slide">
        <h1>OLTP</h1>

        <p>OLTP - On-line Transaction Processing</p>
        <p>Simple queries that read/update a small amount of data related to a single object in the database.</p>
        <p>Fast, short-term operations.</p>
        <p>The load is mostly writes, not reads.</p>

        <p><a href="https://en.wikipedia.org/wiki/Online_transaction_processing">https://en.wikipedia.org/wiki/Online_transaction_processing</a></p>
    </section>

    <section class="slide">
        <h1>OLAP</h1>

        <p>On-line Analyitical Processing</p>
        <p>Longer, more complex queries.</p>
        <p>The queries read and process large amounts of data.</p>
        <p>Various analytical queries (GROUP BY, WINDOW FUNCTION).</p>
        <p>Obtaining new data from data collected on the OLTP side.</p>

        <p><a href="https://en.wikipedia.org/wiki/Online_analytical_processing">https://en.wikipedia.org/wiki/Online_analytical_processing</a></p>
    </section>

    <section class="slide">
        <h1>Storage Model</h1>

        <p>The DBMS can store tuples in a variety of ways that are better suited for OLTP or OLAP workloads.</p>
        <p>So far this semester we have used the n-ary storage model (also known as row store).</p>
    </section>

    <section class="slide">
        <h1>N-ary storage model (NSM)</h1>

        <p>Row store</p>

        <p>The DBMS stores all attributes of one tuple sequentially on the page.</p>
        <p>Ideal for OLTP workloads where queries typically modify single objects.</p>
    </section>

    <section class="slide">
        <h1>N-ary storage model (NSM)</h1>

        <img style="width: 85%; height: auto;" src="pictures/nsm_model_page.png"/>
    </section>

    <section class="slide">
        <h1>N-ary storage model (NSM)</h1>

        <p>System examples: MySQL, PostgreSQL, Oracle.</p>

        <p>Advantages:</p>
        <p>1. Quick insert, update and delete.</p>
        <p>2. Suitable for queries that require the entire tuple.</p>

        <p>Disadvantages:</p>
        <p>1. Not suitable for scanning large portions of a table and/or a subset of attributes.</p>
    </section>

    <section class="slide">
        <h1>Decomposition storage model (DSM)</h1>

        <p>Column store</p>
        <p>The DBMS stores the values of one attribute for all tuples sequentially on the page.</p>
        <p>Ideal for OLAP workloads where read-only queries perform large scans on a subset of table attributes.</p>
    </section>

    <section class="slide">
        <h1>Decomposition storage model (DSM)</h1>
        <img style="width: 85%; height: auto;" src="pictures/dsm_model_page.png"/>
    </section>

    <secion class="slide">
        <h1>Decomposition storage model (DSM)</h1>

        <p>Examples of systems: Vertica, VectorWise, MonetDB, ClickHouse.</p>

        <p>Advantages:</p>
        <p>1. Reduces unnecessary I/O operations because the DBMS reads only the data it needs.</p>
        <p>2. Improved query processing and data compression (more on this later).</p>
        <p>Disadvantages:</p>
        <p>1. Slow for point queries, inserts, updates and deletions due to the fact that the data of one tuple is located in different pages.</p>
    </secion>

    <secion class="slide">
        <h1>DSM tuple identification</h1>

        <p>Fixed-length Offsets.</p>
        <p>Embedded Tuple Identifiers.</p>
    </secion>

    <secion class="slide">
        <h1>DSM fixed-length offsets</h1>

        <p>Each value is the same length for an attribute (INTEGER, CHAR).</p>
        <img style="width: 85%; height: auto;" src="pictures/dsm_fixed_length_offset.png"/>
    </secion>

    <secion class="slide">
        <h1>DSM embedded tuple identifiers</h1>

        <p>Each value in a column is stored with its tuple id.</p>
        <img style="width: 85%; height: auto;" src="pictures/dsm_embedded_ids.png"/>
    </secion>

    <section class="slide">
        <h1>Storage model</h1>

        <p>Storage design is always a trade-off and best choice depends on your workload</p>
        <p>It is important to choose the right storage model for your target workload.</p>
        <p>For OLTP to use row store.</p>
        <p>For OLAP to use column store.</p>
    </section>

    <section class="slide">
        <h1>Questions ?</h1>
    </section>

    <div class="progress"></div>
    <script src="shower/shower.min.js"></script>

    <!--Video plugin-->
    <link rel="stylesheet" href="shower/shower-video.css">
    <script src="shower/shower-video.js"></script>
    <!--/Video plugin-->
</body>
</html>
